php - 在 Debian 中将 PHP 脚本作为守护进程运行

标签 php linux debian daemon init.d

我正在尝试在 Debian 中启动一个 php 脚本作为守护进程。我也希望它能够在启动时启动。

我已经开始使用 /path/to/php/path/to/script/Insert.php & 没有问题,并且可以 shell_exec("nohup/path/to/php/path/to/script/Insert.php >/dev/null &") 也是如此。我已尝试使用以下脚本,但它不会使脚本进入操作状态。

正在将文件复制到 /etc/init.d/ 并使用 update-rc.d ,没有出现问题。我可以使用 service congen-insert start 来“启动”脚本,但它似乎并未实际运行,也没有开始执行任何工作。

我错过了什么,或者我的脚本哪里出了问题?

我知道有几种方法可以解决这个问题,但我真的只是想了解我做错了什么,或者为什么我所做的不起作用。

非常感谢任何帮助或建议!如果您还有其他需要,或者我的描述中遗漏了任何内容,请告诉我,以便我进行更正。

提前致谢。

服务脚本

#! /bin/sh
### BEGIN INIT INFO
# Provides:          congen-insert
# Required-Start:    $local_fs $network
# Required-Stop:     $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: congen-insert
# Description:       DB Insert Daemon
### END INIT INFO

NAME="congen-insert"
DESC=" DB Insert Daemon"
PIDFILE="/var/run/${NAME}.pid"
LOGFILE="/var/log/${NAME}.log"

DAEMON="/path/to/php"
DAEMON_OPTS="/path/to/script/Insert.php"

START_OPTS="--start --background --make-pidfile --pidfile ${PIDFILE} --exec ${DAEMON} ${DAEMON_OPTS}"
STOP_OPTS="--stop --pidfile ${PIDFILE}"

test -x $DAEMON || exit 0

set -e

case "$1" in
    start)
        echo -n "Starting ${DESC}: "
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon $STOP_OPTS
        echo "$NAME."
        rm -f $PIDFILE
        ;;
    restart|force-reload)
        echo -n "Restarting $DESC: "
        start-stop-daemon $STOP_OPTS
        sleep 1
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    status)
    echo -n "Sorry, this isn't implemented yet"
    ;;
    *)
        N=/etc/init.d/$NAME
        echo "Usage: $N {start|stop|restart|force-reload}" >&2
        exit 1
        ;;
esac

exit 0

我尝试运行的脚本:

const LoaderPath = __DIR__ . DIRECTORY_SEPARATOR . ".." .DIRECTORY_SEPARATOR . "includes.php";

require_once  LoaderPath;

use PhpAmqpLib\Channel\AMQPChannel;
use PhpAmqpLib\Message\AMQPMessage;
use requests\InsertRequest;

$connection = GetRabbitConnection();

$channel = $connection->channel();

$RedisClient = GetRedisClient();

DeclareQueues($connection, $RedisClient);

$MySQLHost = $RedisClient->get(MySQLHostKey);
$MySQLUser = $RedisClient->get(MySQLUserKey);
$MySQLPassword = $RedisClient->get(MySQLPasswordKey);
$MySQLDatabase = $RedisClient->get(MySQLDatabaseKey);

$InsertExchange = $RedisClient->get(Insert.":".Exchange);
$InsertQueue = $RedisClient->get(Insert.":".Queue);
$Prefetch = $RedisClient->get(Insert.":".Prefetch);

$RedisClient->disconnect();
$RedisClient = null;

$mysql= new mysqli($MySQLHost, $MySQLUser, $MySQLPassword, $MySQLDatabase);

$channel->basic_qos(0,$Prefetch,false);

$channel->basic_consume($InsertQueue, $InsertExchange, false, false, false, false, "callback");


echo "Consuming on Exchange $InsertExchange with Queue $InsertQueue\n";

while(true) {
    $channel->wait();
}

$channel->close();

function callback(AMQPMessage $message){
    global $mysql;
    echo "Message received", "\n";
    $InsertRequest = new InsertRequest($message->body);

    echo "Running Insert Statement\n";
    if (!$mysql->query($InsertRequest->SQL)){
        echo "Error: ".$mysql->error;
    }

    /** @type AMQPChannel $channel */
    $channel = $message->delivery_info['channel'];
    $channel->basic_ack($message->delivery_info['delivery_tag']);
    echo "Insert Complete\n";

}

最佳答案

问题出在输出的重定向上。我还使用 bash 的 header 修改了 php 文件,因此它不会在顶部显示为多个 php 进程,而是显示文件名:

修改后的服务脚本:

#! /bin/sh

### BEGIN INIT INFO
# Provides:          congen-insert
# Required-Start:    $local_fs $network
# Required-Stop:     $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: congen-insert
# Description:       ConGen DB Insert Daemon
### END INIT INFO

NAME="congen-insert"
DESC="DB Insert Process for ConGen"
PIDFILE="/var/run/${NAME}.pid"
LOGFILE="/var/log/${NAME}.log"

DAEMON="/var/congen/php/controllers/congen-insert"
DAEMON_OPTS="> /dev/null 2>&1"

START_OPTS="--start --background --make-pidfile --pidfile ${PIDFILE} --exec ${DAEMON} ${DAEMON_OPTS}"
STOP_OPTS="--stop --pidfile ${PIDFILE}"

test -x $DAEMON || exit 0

set -e

case "$1" in
    start)
        echo -n "Starting ${DESC}: "
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon $STOP_OPTS
        echo "$NAME."
        rm -f $PIDFILE
        ;;
    restart|force-reload)
        echo -n "Restarting $DESC: "
        start-stop-daemon $STOP_OPTS
        sleep 1
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    status)
    echo -n "Sorry, this isn't implemented yet"
    ;;
    *)
        N=/etc/init.d/$NAME
        echo "Usage: $N {start|stop|restart|force-reload}" >&2
        exit 1
        ;;
esac

exit 0

修改后的 PHP 脚本运行:

#!/php52/php-5.6.6/bin/php
<?php
    const LoaderPath = __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "includes.php";

    require_once  LoaderPath;

    use PhpAmqpLib\Channel\AMQPChannel;
    use PhpAmqpLib\Message\AMQPMessage;
    use requests\InsertRequest;

    $connection = GetRabbitConnection();

    $channel = $connection->channel();

    $RedisClient = GetRedisClient();

    DeclareQueues($connection, $RedisClient);

    $InsertExchange = $RedisClient->get(Insert.":".Exchange);
    $InsertQueue = $RedisClient->get(Insert.":".Queue);
    $Prefetch = $RedisClient->get(Insert.":".Prefetch);

    $RedisClient->disconnect();
    $RedisClient = null;

    $mysql= ConnectionBuilder::GetMySQLi();

    $channel->basic_qos(0,$Prefetch,false);

    $channel->basic_consume($InsertQueue, $InsertExchange, false, false, false, false, "callback");


    echo "Consuming on Exchange $InsertExchange with Queue $InsertQueue\n";

    while(true) {
        $channel->wait();
    }

    $channel->close();

    function callback(AMQPMessage $message){
        global $mysql;
        echo "Message received", "\n";
        $InsertRequest = new InsertRequest($message->body);

        echo "Running Insert Statement\n";
        if (!$mysql->query($InsertRequest->SQL)){
            echo "Error: ".$mysql->error;
        }

        /** @type AMQPChannel $channel */
        $channel = $message->delivery_info['channel'];
        $channel->basic_ack($message->delivery_info['delivery_tag']);
        echo "Insert Complete\n";

    }

将文件添加到 /etc/init.d/ 并使 php 脚本和服务脚本可执行后,我可以使用 service congen-insert start 启动服务> 并像任何其他 init.d 服务一样使用其余命令。

应该注意的是,我将控制台重定向到 /dev/null,但您也可以通过将 /dev/null 替换为重定向到文件可写路径。

another SO post 引用的 2>&1 的解释“2 是 stderr(错误消息)的流编号,1 表示 stdout 流(标准非错误输出)溪流)。”因此,我实质上是将 stdout 重定向到 /dev/null 并将 stderr 重定向到 stdout

关于php - 在 Debian 中将 PHP 脚本作为守护进程运行,我们在Stack Overflow上找到一个类似的问题: https://stackoverflow.com/questions/31108218/

相关文章:

c++ - 没有规则来制作目标 'Main.o' ,需要 'Main' 。停止

linux - 是否有一个 header 提供类似于 uint64_t 的类型,用于 Linux 或 gcc 中的 float 和 double ?

php - 尝试在Docker/php:5.3上安装GMP扩展

PHP:是否可以将数据库层实现为单例?代码里面

php - 无损图像旋转与 PHP

php - 使用 PHP 显示 SQL 数据库中的有限行

php - 如何在我的网站中实现 HSTS

linux - 在 Linux 中,如何判断进程使用了​​多少内存?

java - WEEK_OF_MONTH 返回 0,而 linux 命令返回 1

linux - 从 Debian Snapshot Archives 存储库安装软件包?